# coding=utf-8
import arcpy
from arcpy.sa import *
import pandas as pd
import os
import math

import numpy as np
from datetime import datetime
from arcpy import env
import SyMConn10Lib
from scipy.sparse import coo_matrix
import csv
import sys
import gc
# S1 nulage
# SyM 2.1, Medins Havs och Vattenkonsulter AB
# September 2018

#"C:\Program Files\ArcGIS\Pro\bin\Python\Scripts\propy" E:\Dropbox\Dropbox\HaV\SyM4_20191208\s1_source_sink\modelldata\SyM20_S1_North.py
# Alla shapefiler i följande workspace kommer att beraknas
env.workspace = r"C:\GIS\projekt\HaV_Symphony_2019_3908\SyM4\1_North\shape2"
arcpy.env.overwriteOutput = True
arcpy.env.compression = "LZW"
#lookup_raster Id sparse till centrum koordinat symphony raster (loopar runt denna i funktionen) +1
fLR = r"E:\Dropbox\Dropbox\HaV\SyM4_20191208\s1_source_sink\modelldata\lookup_raster.csv"
flLR = pd.read_table(fLR ,dtype=None, sep=',', header=0, encoding='ISO-8859-1')
#h_fLR_t = flLR.astype(np.float)
h_fLR_t = flLR.values
h_fLR_t = h_fLR_t.astype(dtype=np.float)
#print(h_LR.shape)
#m, n equal length
coolength = h_fLR_t.shape[0]

#print(SensitivityMatrix)
#print(SensitivityMatrix_n)
#Mall-lank till utdata lases in
#fImpactScore = r"C:\GIS\projekt\HaV_Symphony_2019_3908\SyM4\2_East\Mallar\mallImpactScoret.csv"

#Connectivity sink lases in
fConnectivity = r"E:\Dropbox\Dropbox\HaV\SyM4_20191208\s1_source_sink\modelldata\bivalve_30m.txt"
#https://www.stefanoscerra.it/building-large-matrices-faster-coo_matrix-python/
def load_coo_matrix(file_path, separator=",", transpose=False, default_weight=1.):
    with open(file_path) as file:
        reader = csv.reader(file, delimiter=separator)
        iterator = iter(reader)
 
        # data structures for the coo_matrix
        data = []
        rows = []
        cols = []
 
        nodes = 0
        for row in iterator:
            if row:
                source, target = int(float(row[0])), int(float(row[1]))
                #source, target = int(row[0]), int(row[1])
                nodes = max(nodes, source, target)
                rows.append(source)
                cols.append(target)
                if len(row) > 2:
                    weight = float(row[2])
                else:
                    #om matrisen bara har true false
                    weight = default_weight
 
                data.append(weight)
        nodes += 1
 
        # create and return the coo_matrix
        data = np.array(data, dtype=np.float32, copy=False)
        rows = np.array(rows, dtype=np.uint16, copy=False)
        cols = np.array(cols, dtype=np.uint16, copy=False)
        m = coo_matrix((data, (rows, cols) if not transpose else (cols, rows)), shape=(nodes, nodes))
        #return m
        return data, rows, cols
        
#cooConnectivity = load_coo_matrix(fConnectivity)
h_cooD, h_cooR, h_cooC = load_coo_matrix(fConnectivity)
h_cooR = h_cooR.astype(dtype=np.uint16)
h_cooC = h_cooC.astype(dtype=np.uint16)
# coo matrise lenght
nzz = h_cooD.shape[0]
#npConnectivity = np.zeros(shape=[cooConnectivity.shape[0]], dtype=np.float32)

#npConnectivity = cooConnectivity.sum(0) #axis 1 = row, 0 = cols
#print(npConnectivity)
#print(npConnectivity.shape)
#f = open(r"E:\Dropbox\Dropbox\HaV\SyM4_20191208\s1_source_sink\data\Conn_sum_col.csv", 'a')
#for i in range(0,cooConnectivity.shape[1]-1):
#    f.write(str(npConnectivity[0,i]) + "\n")
#sys.exit()
#-----------------------------------------------------------------

f = open(r"E:\Dropbox\Dropbox\HaV\SyM4_20191208\s1_source_sink\data\Impact_omr_statistik.csv", 'a')
f.write("omr;Total;Mean;StdDev;Min;Max\n")
f.close()

f = open(r"E:\Dropbox\Dropbox\HaV\SyM4_20191208\s1_source_sink\modelldata\East_Beräkningslog.csv", 'a')
f.write("Beräknad med SyM 2.0\n")
f.write("Medins Havs och Vattenkonsulter AB\n\n")
f.write("Beräknade områden\n")
f.close()
ftempSG = os.path.join(r"C:\GIS\projekt\HaV_Symphony_2019_3908\SyM4\standard_grid", "Standardgrid_Symphony_Conn.tif")
rSG = arcpy.Raster(ftempSG)
arcpy.env.extent = ftempSG
descSG = arcpy.Describe(rSG)
SR = rSG.spatialReference
#till utdata raster, samma form som Standardgrid SG
lowerLeft = arcpy.Point(rSG.extent.XMin,rSG.extent.YMin)
cellSize = 250
#extant SG
SG_Y_max = rSG.extent.YMax
SG_Y_min = rSG.extent.YMin
SG_X_max = rSG.extent.XMax
SG_X_min = rSG.extent.XMin
SG_Y_diff = SG_Y_max - SG_Y_min
SG_X_diff = SG_X_max - SG_X_min
print(SG_Y_min)
print(SG_X_min)
arcpy.env.extent = ftempSG
arcpy.env.outputCoordinateSystem = SR
for i in range(h_fLR_t.shape[0]):

    h_fLR_t[i, 1] = round( ((h_fLR_t[i, 1] - SG_X_min) / SG_X_diff) * 5640 ,0)
    h_fLR_t[i, 2] = round( ((h_fLR_t[i, 2] - SG_Y_min) / SG_Y_diff) * 5720 ,0)
    
h_fLR_t = h_fLR_t.astype(dtype=np.float32)
h_fLR_t = h_fLR_t.ravel("F")
h_fLR = h_fLR_t.copy()
h_RSGso_t = np.zeros(shape=[rSG.height, rSG.width], dtype=np.float32)
h_RSGsi_t = np.zeros(shape=[rSG.height, rSG.width], dtype=np.float32)
#resultat Rso = source, Rsi = sink
h_Rso_t = np.zeros(shape=[coolength], dtype=np.float32)
print("8a")
h_Rsi_t = np.zeros(shape=[coolength], dtype=np.float32)
print("8aa")
h_IS_tm = np.zeros(shape=[coolength], dtype=np.float32)


shapes = arcpy.ListFeatureClasses()
#loopar igenom alla shapefiler i workspace
first = 1
for shp in shapes:
    try:
        desc = arcpy.Describe(shp)
        omr = desc.baseName
        print(omr + " " +(str(datetime.now())).split('.')[0])


        #raster indata IS= Impactscore SG = standard grid
        ftemp = os.path.join(r"E:\Dropbox\Dropbox\HaV\SyM4_20191208\s1_Mussels\GIS\s1_impact", "S1_" + omr + ".tif")
        rIStemp = arcpy.Raster(ftemp)

        ftemp = os.path.join(r"C:\GIS\projekt\HaV_Symphony_2019_3908\SyM4\1_North\shape2", "mask_" + omr + ".tif")
        rMtemp = arcpy.Raster(ftemp)
        #Connectivity sink mask lases in (startar index med 1 inte 0) 
        #ftemp = os.path.join(r"C:\GIS\projekt\HaV_Symphony_2019_3908\SyM4\2_East\shape2_connectivity", "CMask_" + omr + ".tif")
        ftemp = r"C:\GIS\projekt\HaV_Symphony_2019_3908\SyM4\connectivity\Connectivity_sparseID_0.tif"
        rCM = arcpy.Raster(ftemp)

        rIS = rSG + rIStemp
        rM = rSG + rMtemp

        #Raster till numpy array
        h_IS_t = np.zeros(shape=[rSG.height, rSG.width], dtype=np.float32)

        print("4")
        h_SG = np.zeros(shape=[rSG.height, rSG.width], dtype=np.uint16)
        print("5")
        h_M = np.zeros(shape=[rSG.height, rSG.width], dtype=np.uint16)
        print("6")
        h_CM_t = np.zeros(shape=[rSG.height, rSG.width], dtype=np.uint16)
        print("7")
        Ylength = h_IS_t.shape[0]
        print("8")
        Xlength = h_IS_t.shape[1]
        print("8a")
        #print(h_IS_t.shape[1])

        #resultat Rso = source, Rsi = sink
        #h_Rso_t = np.zeros(shape=[coolength], dtype=np.float32)
        print("8a")
        #h_Rsi_t = np.zeros(shape=[coolength], dtype=np.float32)
        print("8aa")
        #h_IS_tm = np.zeros(shape=[coolength], dtype=np.float32)
        print("8aaa")
        #h_RSGso_t = np.zeros(shape=[rSG.height, rSG.width], dtype=np.float32)
        #h_RSGsi_t = np.zeros(shape=[rSG.height, rSG.width], dtype=np.float32)
        print("9")    
        h_IS_t = arcpy.RasterToNumPyArray(rIS,nodata_to_value=0)
        h_SG = arcpy.RasterToNumPyArray(rSG,nodata_to_value=0)
        h_M = arcpy.RasterToNumPyArray(rM,nodata_to_value=0)
        h_CM_t = arcpy.RasterToNumPyArray(rCM,nodata_to_value=0)
        print("10") 
        h_IS_t = h_IS_t.astype(dtype=np.float32)
        h_SG = h_SG.astype(dtype=np.uint16)
        h_M = h_M.astype(dtype=np.uint16)
        h_CM_t = h_CM_t.astype(dtype=np.uint16)
        print("11") 
        h_IS_tr = h_IS_t.ravel("C")
        h_SG_r = h_SG.ravel("C")
        h_M_r = h_M.ravel("C")
        h_CM_tr = h_CM_t.ravel("C")

        h_RSGso_tr = h_RSGso_t.ravel("C")
        h_RSGsi_tr = h_RSGsi_t.ravel("C")
        h_RSGso = h_RSGso_tr.copy()

        print("12") 
        print(h_IS_tr.shape) 
        h_IS = h_IS_tr.copy()
        print(h_IS.shape)       
        print("13")
        h_RSGsi = h_RSGsi_tr.copy()
        h_CM = h_CM_tr.copy()
        h_Rso = h_Rso_t.copy()
        h_Rsi = h_Rso_t.copy()
        h_M = h_M_r.copy()
        h_SG = h_SG_r.copy()

        #SyMConn10Lib.cSyMConn10(IS_h, SG_h, M_h, CM_h, Rso_h, Rsi_h, cooData, cooRow, cooCol, LR)
        SyMConn10Lib.cSyMConn10( \
            h_IS,\
            h_SG,\
            h_M,\
            h_CM,\
            h_Rso,\
            h_Rsi,\
            h_cooD,\
            h_cooR,\
            h_cooC,\
            h_fLR,\
            Ylength,\
            Xlength,\
            coolength,\
            h_IS_tm,\
            h_RSGso,\
            h_RSGsi,\
            nzz)
        #-----------------------------------------------------------
        print("klar")

        #print(np.amax(h_IS_tm))


        h_RSGso_res = np.reshape(h_RSGso, (Ylength,Xlength))
        h_RSGso_res = h_RSGso_res.astype(dtype=np.float32)
        #newRaster = arcpy.NumPyArrayToRaster(h_RSGso_t, lowerLeft, cellSize, cellSize, value_to_nodata=-1)
        newRaster = arcpy.NumPyArrayToRaster(h_RSGso_res, lowerLeft, cellSize, cellSize, value_to_nodata = 0)
        #ftemp = os.path.join(r"E:\Dropbox\Dropbox\HaV\SyM4_20191208\s1_source_sink\GIS\temp", "source_" + omr + ".tif")
        #ftemp1 = os.path.join(r"E:\Dropbox\Dropbox\HaV\SyM4_20191208\s1_source_sink\GIS\source", "source_" + omr + ".tif")
        ftemp = os.path.join(r"E:\Dropbox\Dropbox\HaV\SyM4_20191208\s1_source_sink\GIS\source\source.gdb", "source_" + omr)
        #arcpy.env.compression = "LZW"

        newRaster.save(ftemp)
        #arcpy.RasterToOtherFormat_conversion(ftemp, r"E:\Dropbox\Dropbox\HaV\SyM4_20191208\s1_source_sink\GIS\source", "TIFF")

        h_RSGsi_res = np.reshape(h_RSGsi, (Ylength,Xlength))
        h_RSGsi_res = h_RSGsi_res.astype(dtype=np.float32)
        #newRaster = arcpy.NumPyArrayToRaster(h_RSGsi_t, lowerLeft, cellSize, cellSize, value_to_nodata=-1)
        newRaster = arcpy.NumPyArrayToRaster(h_RSGsi_res, lowerLeft, cellSize, cellSize, value_to_nodata = 0)
        ftemp = os.path.join(r"E:\Dropbox\Dropbox\HaV\SyM4_20191208\s1_source_sink\GIS\sink\sink.gdb", "sink_" + omr)
        #ftemp = os.path.join(r"E:\Dropbox\Dropbox\HaV\SyM4_20191208\s1_source_sink\GIS\temp", "sink_" + omr + ".tif")
        #ftemp1 = os.path.join(r"E:\Dropbox\Dropbox\HaV\SyM4_20191208\s1_source_sink\GIS\sink", "sink_" + omr + ".tif")
        newRaster.save(ftemp)
        del rIStemp
        #del rMtemp
        #del rCM
        del rIS
        #del rM
        gc.collect()

        #for i in range(30000, 31000):
        #    print(h_IS_tm[i])    
    except Exception:
        e = sys.exc_info()[1]
        print(e.args[0])